"""
Enable optimizations on the math module.
"""

from astoptimizer.compatibility import (
    PYTHON3,
    check_unicode_subscript,
    INT_TYPES, FLOAT_TYPES, COMPLEX_TYPES,
    NATIVE_STR, BYTES_TYPE, UNICODE_TYPE, STR_TYPES)
from astoptimizer.config import check_1arg, check_args
import math

def setup_config(config):
    config.constants.update({
        'math.e': math.e,
        'math.pi': math.pi,
    })

    # FIXME: register all math functions
    config.pure_functions.update({
        'math.pow': (check_args(2, 2, FLOAT_TYPES, FLOAT_TYPES), math.pow),
        'math.sqrt': (check_1arg(FLOAT_TYPES), math.sqrt),
        'math.exp': (check_1arg(FLOAT_TYPES), math.exp),
        'math.log': (check_1arg(FLOAT_TYPES), math.log),
    })

